﻿/*
== startdoc
= @(#) Program.cs
;;; @(%) $OPT_CONTENTLEVEL = 4
;;; @(%) $OPT_PROGLISTIGNORE = false
;;; (File "dropboxdata.lnk" "xyzzy/insert/template.cs")
;;; (File "c:/tools/xyzzy/cbarlocal/progform.sample/csform.cs")
;;;
;;; 漢字コードを utf8 にするには、C-x C-k f として、utf8 と入力。
;;;
;;; つぎの行は、このファイルに埋め込まれている説明文の中で、数式
;;; を記述するために書いています。
$math
;;;
このコードは、myarghelper.exe のソースコードです。このファイルだけで完結しています。

説明のためのファイル 
(File "./myarghelper.exe.txt")
があります。

------------------------------------------------------------
* using 文

;;; @(%) $fontcolor = "crimson"
@begin{code}{proglist}
*/

using System;
using System.Collections.Generic;
using System.Windows.Forms;
using System.IO;
using System.Diagnostics;             // To use the Process class
using System.Text.RegularExpressions; // To use Regex
using System.Reflection;
/*
@end{code}

------------------------------------------------------------
* namespace myarghelper の定義

;;; @(%) $fontcolor = "crimson"
@begin{code}{proglist}
*/

namespace myarghelper
{
/*
@end{code} -------------------------------------------------

------------------------------------------------------------
** クラス Program の定義

;;; @(%) $fontcolor = "crimson"
@begin{code}{proglist}
*/
   static class Program
   {
      /// <summary>
      /// アプリケーションのメイン エントリ ポイントです。
      /// </summary>
      [STAThread]
      static void Main(string[] args)
      {
        string version = "2.2016-08-02.1";

        // Read ini file
        string _path = Application.ExecutablePath;
        string _name = Path.GetFileNameWithoutExtension(_path);
        string _dir = Path.GetDirectoryName(_path);
        string _ahpfile = _dir + "\\" + _name + ".ahp";
     
        if (args.Length > 0 && args[0] == "/myarghelperversion")
        {
          // 引数として、/myarghelperversion が指定されました。
          string asmblyname =
  Assembly.GetExecutingAssembly().GetName().Name.ToString();

          MessageBox.Show(_name + ".exe is a copy of\n\n" + 
               asmblyname + ".exe " + version);
          Application.Exit();
          System.Environment.Exit(0);
        }

        // 当然のことながら、args には、myarghelper.exe を複写
        // してできた、たとえば、hoge.exe を実際に起動したとき
        // の引数が格納されています。

        if (args.Length > 0 && args[0] == "//help")
        {
          // //help オプションが指定されました。このプログラ
          // ムがどんな名前で複写されているかを考慮して、
          // commentfile を決めて開きます。
          
          string commentfile = _dir + "\\" + _name + ".exe.txt";
          if (File.Exists(commentfile))
          {
               MessageBox.Show(_name + ".exe.txt" + " is shown by the start command.");
               System.Diagnostics.Process.Start(commentfile);
          }
          else
          {
               MessageBox.Show(commentfile + " does not exist.");
          }
          Application.Exit();
          System.Environment.Exit(0);
        }

        string computername =
            System.Environment.GetEnvironmentVariable("COMPUTERNAME");
        string ahpfileForThisMachine = _dir + "\\" + _name + "For" +
            computername + ".ahp";

        if (System.IO.File.Exists(ahpfileForThisMachine) == true)
        {
            _ahpfile = ahpfileForThisMachine;
        }

        if (System.IO.File.Exists(_ahpfile) == false)
        {
            MessageBox.Show(_name + ".exe の設定ファイル（拡張子 .ahp）が\n\n" +
              _dir + "\n\nに在りません。" +
              "\n\n" + _name + ".exe は myarghelper.exe から作成されました。",                             
              _name + ".exe " + version);
            Application.Exit();
            System.Environment.Exit(0);
        }

        string[] vlines = ReadValidLines(_ahpfile);
        // ReadValidLines はコメント行を読み飛ばして、それ以外
        // の行を配列の形で返します。

        if (vlines.Length < 1)
        {
            MessageBox.Show("ahpfile " +
              _ahpfile + " is empty.", _name + ".exe " + version);
            Application.Exit();
            System.Environment.Exit(0);

        }

        string thisprog_arguments = "";

        Regex theRegCommandQuote = new Regex(@"^\""[^\""]+\""[ ]*(?<line>.*)$");
        Match m1 = theRegCommandQuote.Match( Environment.CommandLine);

        if (m1.Success)
        {
            // MessageBox.Show(m1.Groups["line"].Value, "Debug");
            thisprog_arguments = m1.Groups["line"].Value;
        }
        else
        {
            Regex theRegCommand = new Regex(@"^[^ ][^ ]*[ ]+(?<line>.*)$");
            Match m2 = theRegCommand.Match(Environment.CommandLine);
            if (m2.Success)
            {
               // MessageBox.Show(m2.Groups["line"].Value, "Debug");
               thisprog_arguments = m2.Groups["line"].Value;
            }
        }         
        // ここの操作で thisprog_arguments に引数が格納されました。

        string currentDirectory = Directory.GetCurrentDirectory();
        if (Regex.IsMatch(thisprog_arguments, @"^\.\\")) {
            thisprog_arguments = Regex.Replace(thisprog_arguments,
               @"^\.(.*)$", (currentDirectory + @"$1"));
        }
        else if (Regex.IsMatch(thisprog_arguments, @"^\""\.\\")) {
            thisprog_arguments = Regex.Replace(thisprog_arguments,
               @"^\""\.(.*)$", (@"\""" + currentDirectory + @"$1"));
        }
        
        string filename = vlines[0];

        // [2016-08-02] 環境変数を利用できるようにしました。
        // %XYZZYHOME% とかを vlines[0] の中に書くことができます。
        Regex theEnvReg = new Regex(@"%(?<var>[^%]+)%");
        bool checkenv = true;
        while (checkenv)
        {
          Match mf = theEnvReg.Match(filename);
          if (mf.Success)
          {
            string varname = mf.Result("${var}");
            string value = System.Environment.GetEnvironmentVariable(varname);
            if (value == null)
            {
              MessageBox.Show("ahpfile " +
                _ahpfile + "\n\n\nEnvironmental variable " + varname + 
                " is not defined.",
                _name,
                MessageBoxButtons.OK, MessageBoxIcon.Error
                );
              Application.Exit();
              System.Environment.Exit(0);
            }
            filename = filename.Replace("%" + varname + "%", value);
          }
          else
          {
            checkenv = false;
          }
        }

        filename = Regex.Replace(filename, @"^\.\\", _dir + "\\");
        filename = Regex.Replace(filename, "\\\\", "\\");

        string ahpargument = "";
        if (vlines.Length > 1) { ahpargument = vlines[1]; }

        string arguments = "";
        bool replaceEnvironmenVariablesP = true;

        if (vlines.Length > 1)
        {
            if (vlines[1].Length > 0)
            {
              arguments = vlines[1];
              if (Regex.IsMatch(arguments, @"^-norepenv")) {
                replaceEnvironmenVariablesP = false;
                arguments = Regex.Replace(arguments,
                  @"^-norepenv[ ]*(.*)$",@"$1");
              }

               arguments = Regex.Replace(arguments, @"^\.\\", _dir + "\\");
               arguments = Regex.Replace(arguments, @"\\\\", @"\");
               //MessageBox.Show(arguments);

               if (Regex.IsMatch(arguments, @"\$\(Arguments\)"))
               {
                  arguments = arguments.Replace("$(Arguments)", thisprog_arguments);

               }
               else if (Regex.IsMatch(arguments, @"\$\(Argument1\)"))
               {
                  string[] cargs = Environment.GetCommandLineArgs();
                  // cargs[0] は実行プログラムのパス、cargs[1] 
                  // 以降に引数が格納されています。
                  int nargs = cargs.Length;
                  if (nargs > 1 && Regex.IsMatch(cargs[0], @"^\.\\"))
                  {
                     cargs[1] = Regex.Replace(cargs[1], @"^\.(.*)$",
                        (currentDirectory + @"$1"));
                  }

                  int iarg = 1;
                  if (nargs > iarg)
                  {
                     arguments = arguments.Replace("$(Argument1)", cargs[iarg]);
                     iarg += 1;
                  }

                  if (Regex.IsMatch(arguments, @"\$\(Argument2\)"))
                  {
                     if (nargs > iarg)
                     {
                        arguments = arguments.Replace("$(Argument2)", cargs[iarg]);
                        iarg += 1;
                     }

                     if (Regex.IsMatch(arguments, @"\$\(Argument3\)"))
                     {
                        if (nargs > iarg)
                        {
                           arguments = arguments.Replace("$(Argument3)", cargs[iarg]);
                           iarg += 1;
                        }
                     }

                  }

                  if (nargs > iarg)
                  {
                     for (int i = iarg; i < nargs; i++)
                     {
                        if (cargs[i].Contains(" "))
                        {
                           arguments = arguments + " \"" + cargs[i] + "\"";
                        }
                        else
                        {
                           arguments = arguments + " " + cargs[i];
                        }
                     }
                  }
               }
               else
               {
                  if (thisprog_arguments.Length > 0)
                  {
                     arguments = arguments + " " + thisprog_arguments;
                  }
                  //else
                  //{
                  //   arguments = vlines[1];
                  //}
               }
            }
            else
            {
               // ahpfile には引数が指定されていなかった。
               arguments = thisprog_arguments;
            }
         }
         else
         {
            arguments = thisprog_arguments;
         }

         if (Regex.IsMatch(arguments, @"\$\(Argument.*\)"))
         {
               MessageBox.Show(_name + ".exe の設定ファイル " +
                  Path.GetFileName(_ahpfile) + " の記述に" +
                  "誤りがあります。\n\n" +
                  "vlines[1]: " + vlines[1] + "\n" + 
                  "arguments: " + thisprog_arguments,
                 _name + ".exe " + version);
               Application.Exit();
               System.Environment.Exit(0);
         }

         if (args.Length > 0 && args[0] == "/myarghelperinfo")
         {
            string messageformat = @"
ahpfile:  {0}

実行プログラム名:  {1}
実プログラム引数:  {2}
";

            string asmblyname =
  Assembly.GetExecutingAssembly().GetName().Name.ToString();

            MessageBox.Show(_name + ".exe is a copy of\n\n" +
               asmblyname + ".exe " + version + "\n\n" + 
               String.Format(messageformat,
                 _ahpfile, filename, ahpargument)               
               , _name + ".exe");
            Application.Exit();
            System.Environment.Exit(0);
         }

      // [2016-08-02] 環境変数を利用できるようにしました。
      // %XYZZYHOME% とかを arguments の中に書くことができます。
      // これが問題を引き起こすこともあります。それが具合が悪い
      // 場合は、オプション -norepenv を指定してください。
      if (replaceEnvironmenVariablesP) {
        checkenv = true;
        while (checkenv)
        {
          Match ma = theEnvReg.Match(arguments);
          if (ma.Success)
          {
            string varname = ma.Result("${var}");
            string value = System.Environment.GetEnvironmentVariable(varname);

            if (value == null)
            {
              MessageBox.Show("ahpfile " +
                _ahpfile + "\n\n\nEnvironmental variable " + varname +
                " is not defined." +
                "\n\n\nこのメッセージは、" + _name + 
                " の素となった myarghelper.exe が生成しました。\n\n" +
                "myarghelper.exe.txt をご覧ください。\n\n" +
                ".ahp ファイルの中で -norepenv を指定すると問題が解決する可能性があります。", _name,
                MessageBoxButtons.OK, MessageBoxIcon.Error
                );
              Application.Exit();
              System.Environment.Exit(0);
            }

            arguments = arguments.Replace("%" + varname + "%", value);
          }
          else
          {
            checkenv = false;
          }
        }
      }

      // ここまでで、filename と arguments の作成を完了しています。

      // filename が start かそうでないかで動作を変えます。
      string filename1 = filename.ToLower();
         if (filename1 == "start" || filename1 == "start.exe")
         {
            System.Diagnostics.Process.Start(arguments);
         }
         else
         {
            // filename に格納されているファイルがあるかどうかチェックする
            // 必要がないか。
            if (System.IO.File.Exists(filename) == false)
            {
              MessageBox.Show("ahpfile " +
              _ahpfile + "\n\n\n" + filename +
              " dofes not exist.", _name,
              MessageBoxButtons.OK,
              MessageBoxIcon.Error
              );
              Application.Exit();
              System.Environment.Exit(0);
            }

            Process prcs = new Process();
            prcs.StartInfo.FileName = filename;
            prcs.StartInfo.Arguments = arguments;
            prcs.StartInfo.UseShellExecute = true;
            prcs.StartInfo.RedirectStandardOutput = false;
            prcs.StartInfo.CreateNoWindow = false;
            prcs.Start();
         }

         // prcs.WaitForExit();


         //Application.EnableVisualStyles();
         //Application.SetCompatibleTextRenderingDefault(false);
         //Application.Run(new Form1());
      }

      static string[] ReadValidLines(string filename)
      {
         string[] lines = File.ReadAllLines(filename,
            System.Text.Encoding.GetEncoding("shift_jis"));
         List<string> vlines = new List<string>();
         for (int i = 0; i < lines.Length; i++)
         {
            if (lines[i].Length > 0 && lines[i].Substring(0, 1) == "#")
               continue;

            vlines.Add(lines[i]);
         }
         string[] nlines = new string[vlines.Count];
         vlines.CopyTo(nlines, 0);
         return nlines;
      }

      static string cutshort(string path, int maxlen)
      {
         // Parent folder
         string displayPath = path;
         string parentDir = Path.GetDirectoryName(displayPath);
         string lastDir = Path.GetFileName(path);

         Regex theEndWithYen = new Regex(@".*\\$");
         Match theMatchEndWithYen = theEndWithYen.Match(parentDir);

         while (displayPath.Length > maxlen && theMatchEndWithYen.Success == false)
         {
            parentDir = Path.GetDirectoryName(parentDir);
            displayPath = parentDir + "\\...\\" + lastDir;
            theMatchEndWithYen = theEndWithYen.Match(parentDir);
         }
         return displayPath;
      }
/*
@end{code} -------------------------------------------------

------------------------------------------------------------
*** class Program の定義終了

;;; @(%) $fontcolor = "crimson"
@begin{code}{proglist}
*/

   } // end of definition of class Program
/*
@end{code}

------------------------------------------------------------
** namespace myarghelper の定義終了

;;; @(%) $fontcolor = "crimson"
@begin{code}{proglist}
*/

} // end of namespace myarghelper
/*
@end{code}
  
== enddoc
*/
